// OperationMouseDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "OperationMouseDlg.h"
//#include "afxdialogex.h"


// COperationMouseDlg _CAO

IMPLEMENT_DYNAMIC(COperationMouseDlg, CDialog)

COperationMouseDlg::COperationMouseDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COperationMouseDlg::IDD, pParent)
{

}

COperationMouseDlg::~COperationMouseDlg()
{
}

void COperationMouseDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK_ONLINE_INVERT, m_xcCheckOnlineInvert);
	DDX_Control(pDX, IDC_CMB_ONLINE_WHEEL, m_xcCmbOnlineWheel);
	DDX_Control(pDX, IDC_CMB_ONLINE_MCLICK, m_xcCmbOnlineMClick);
	DDX_Control(pDX, IDC_CMB_ONLINE_LDBLCLICK, m_xcCmbOnlineLDBLClick);
	DDX_Control(pDX, IDC_CHECK_OFFLINE_INVERT, m_xcCheckOfflineInvert);
	DDX_Control(pDX, IDC_CMB_OFFLINE_WHEEL, m_xcCmbOfflineWheel);
	DDX_Control(pDX, IDC_CMB_OFFLINE_MCLICK, m_xcCmbOfflineMClick);
	DDX_Control(pDX, IDC_CMB_OFFLINE_LDBLCLICK, m_xcCmbOfflineLDBLClick);
	DDX_Control(pDX, IDC_CHECK_STATUS_TRANSFER, m_xcCheckStatusTransfer);
	DDX_Control(pDX, IDC_CHECK_STATUS_INVERT, m_xcCheckStatusInvert);
	DDX_Control(pDX, IDC_CMB_STATUS_WHEEL, m_xcCmbStatusWheel);
	DDX_Control(pDX, IDC_CMB_STATUS_MCLICK, m_xcCmbStatusMClick);
	DDX_Control(pDX, IDC_CHECK_SEEK_TRANSFER, m_xcCheckSeekTransfer);
	DDX_Control(pDX, IDC_CHECK_SEEK_INVERT, m_xcCheckSeekInvert);
	DDX_Control(pDX, IDC_CMB_SEEK_WHEEL, m_xcCmbSeekWheel);
	DDX_Control(pDX, IDC_CMB_SEEK_MCLICK, m_xcCmbSeekMClick);
	DDX_Control(pDX, IDC_CHECK_BBS_TRANSFER, m_xcCheckBBSTransfer);
	DDX_Control(pDX, IDC_CHECK_BBS_INVERT, m_xcCheckBBSInvert);
	DDX_Control(pDX, IDC_CMB_BBS_WHEEL, m_xcCmbBBSWheel);
	DDX_Control(pDX, IDC_CMB_BBS_MCLICK, m_xcCmbBBSMClick);
}


BEGIN_MESSAGE_MAP(COperationMouseDlg, CDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &COperationMouseDlg::OnBnClickedBtnAllDefault)
	ON_BN_CLICKED(IDC_CHECK_STATUS_TRANSFER, &COperationMouseDlg::OnBnClickedCheckStatusTransfer)
	ON_BN_CLICKED(IDC_CHECK_SEEK_TRANSFER, &COperationMouseDlg::OnBnClickedCheckSeekTransfer)
	ON_BN_CLICKED(IDC_CHECK_BBS_TRANSFER, &COperationMouseDlg::OnBnClickedCheckBBSTransfer)
END_MESSAGE_MAP()


void COperationMouseDlg::wheelInsertString(CComboBox& cmb)
{
	cmb.InsertString(0, L"Ȃ");
	cmb.InsertString(1, L"ʕύX");
	cmb.InsertString(2, L"V[N");
	cmb.InsertString(3, L"XbhXN[");
}

void COperationMouseDlg::mclickInsertString(CComboBox& cmb)
{
	cmb.InsertString(0, L"Ȃ");
	cmb.InsertString(1, L"~[g");
	cmb.InsertString(2, L"ŏ~[g");
	cmb.InsertString(3, L"ꎞ~");
	cmb.InsertString(4, L"ŏꎞ~");
	cmb.InsertString(5, L"XbhXN[Zbg");
	cmb.InsertString(6, L"XbhXV");
	cmb.InsertString(7, L"BBSݗ\");
}

void COperationMouseDlg::ldblclickInsertString(CComboBox& cmb)
{
	cmb.InsertString(0, L"Ȃ");
	cmb.InsertString(1, L"Sʉ");
	cmb.InsertString(2, L"ő剻");
	cmb.InsertString(3, L"{100%");
	cmb.InsertString(4, L"100%/Sʉ");
	cmb.InsertString(5, L"100%/ő剻");
}

int COperationMouseDlg::wheelSwitch(int x)
{
	switch(x)
	{
	case sl::MOUSE_WHEEL_NONE:		return 0;
	case sl::MOUSE_WHEEL_VOLUME:	return 1;
	case sl::MOUSE_WHEEL_SEEK:		return 2;
	case sl::MOUSE_WHEEL_THREAD:	return 3;
	};
	return 1;
}

int COperationMouseDlg::mclickSwitch(int x)
{
	switch(x)
	{
	case sl::MOUSE_MCLICK_NONE:				return 0;
	case sl::MOUSE_MCLICK_MUTE:				return 1;
	case sl::MOUSE_MCLICK_MINIMIZE_MUTE:	return 2;
	case sl::MOUSE_MCLICK_PAUSE:			return 3;
	case sl::MOUSE_MCLICK_MINIMIZE_PAUSE:	return 4;
	case sl::MOUSE_MCLICK_THREAD_RESET:		return 5;
	case sl::MOUSE_MCLICK_THREAD_RELOAD:	return 6;
	case sl::MOUSE_MCLICK_BBS_EDIT:			return 7;
	};
	return 1;
}

int COperationMouseDlg::ldblclickSwitch(int x)
{
	switch(x)
	{
	case sl::MOUSE_LDBLCLICK_NONE:					return 0;
	case sl::MOUSE_LDBLCLICK_FULLSCREEN:			return 1;
	case sl::MOUSE_LDBLCLICK_MAXIMIZE:				return 2;
	case sl::MOUSE_LDBLCLICK_ZOOM100:				return 3;
	case sl::MOUSE_LDBLCLICK_ZOOM100_FULLSCREEN:	return 4;
	case sl::MOUSE_LDBLCLICK_ZOOM100_MAXIMIZE:		return 5;
	};
	return 1;
}

void COperationMouseDlg::init()
{
	m_xcCheckOnlineInvert.SetCheck(mouse_.online.invert ? BST_CHECKED : BST_UNCHECKED);
	m_xcCmbOnlineWheel.SetCurSel(wheelSwitch(mouse_.online.wheel));
	m_xcCmbOnlineMClick.SetCurSel(mclickSwitch(mouse_.online.mclick));
	m_xcCmbOnlineLDBLClick.SetCurSel(ldblclickSwitch(mouse_.online.ldblclick));

	m_xcCheckOfflineInvert.SetCheck(mouse_.offline.invert ? BST_CHECKED : BST_UNCHECKED);
	m_xcCmbOfflineWheel.SetCurSel(wheelSwitch(mouse_.offline.wheel));
	m_xcCmbOfflineMClick.SetCurSel(mclickSwitch(mouse_.offline.mclick));
	m_xcCmbOfflineLDBLClick.SetCurSel(ldblclickSwitch(mouse_.offline.ldblclick));

	m_xcCheckStatusTransfer.SetCheck(mouse_.status.transfer ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckStatusInvert.SetCheck(mouse_.status.invert ? BST_CHECKED : BST_UNCHECKED);
	m_xcCmbStatusWheel.SetCurSel(wheelSwitch(mouse_.status.wheel));
	m_xcCmbStatusMClick.SetCurSel(mclickSwitch(mouse_.status.mclick));
	statusEnableWindow();

	m_xcCheckSeekTransfer.SetCheck(mouse_.seek.transfer ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckSeekInvert.SetCheck(mouse_.seek.invert ? BST_CHECKED : BST_UNCHECKED);
	m_xcCmbSeekWheel.SetCurSel(wheelSwitch(mouse_.seek.wheel));
	m_xcCmbSeekMClick.SetCurSel(mclickSwitch(mouse_.seek.mclick));
	seekEnableWindow();

	m_xcCheckBBSTransfer.SetCheck(mouse_.bbs.transfer ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckBBSInvert.SetCheck(mouse_.bbs.invert ? BST_CHECKED : BST_UNCHECKED);
	m_xcCmbBBSWheel.SetCurSel(wheelSwitch(mouse_.bbs.wheel));
	m_xcCmbBBSMClick.SetCurSel(mclickSwitch(mouse_.bbs.mclick));
	bbsEnableWindow();
}

void COperationMouseDlg::statusEnableWindow()
{
	BOOL enable = m_xcCheckStatusTransfer.GetCheck() == BST_CHECKED ? FALSE : TRUE;
	m_xcCheckStatusInvert.EnableWindow(enable);
	m_xcCmbStatusWheel.EnableWindow(enable);
	m_xcCmbStatusMClick.EnableWindow(enable);
}

void COperationMouseDlg::seekEnableWindow()
{
	BOOL enable = m_xcCheckSeekTransfer.GetCheck() == BST_CHECKED ? FALSE : TRUE;
	m_xcCheckSeekInvert.EnableWindow(enable);
	m_xcCmbSeekWheel.EnableWindow(enable);
	m_xcCmbSeekMClick.EnableWindow(enable);
}

void COperationMouseDlg::bbsEnableWindow()
{
	BOOL enable = m_xcCheckBBSTransfer.GetCheck() == BST_CHECKED ? FALSE : TRUE;
	m_xcCheckBBSInvert.EnableWindow(enable);
	m_xcCmbBBSWheel.EnableWindow(enable);
	m_xcCmbBBSMClick.EnableWindow(enable);
}

// COperationMouseDlg bZ[W nh[


BOOL COperationMouseDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	wheelInsertString(m_xcCmbOnlineWheel);
	mclickInsertString(m_xcCmbOnlineMClick);
	ldblclickInsertString(m_xcCmbOnlineLDBLClick);

	wheelInsertString(m_xcCmbOfflineWheel);
	mclickInsertString(m_xcCmbOfflineMClick);
	ldblclickInsertString(m_xcCmbOfflineLDBLClick);

	wheelInsertString(m_xcCmbStatusWheel);
	mclickInsertString(m_xcCmbStatusMClick);

	wheelInsertString(m_xcCmbSeekWheel);
	mclickInsertString(m_xcCmbSeekMClick);

	wheelInsertString(m_xcCmbBBSWheel);
	mclickInsertString(m_xcCmbBBSMClick);

	init();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL COperationMouseDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void COperationMouseDlg::OnDestroy()
{
	CDialog::OnDestroy();

	auto wheelID = [](int x)->int{
		switch(x)
		{
		case 0: return sl::MOUSE_WHEEL_NONE;
		case 1: return sl::MOUSE_WHEEL_VOLUME;
		case 2: return sl::MOUSE_WHEEL_SEEK;
		case 3: return sl::MOUSE_WHEEL_THREAD;
		};
		return sl::MOUSE_WHEEL_VOLUME;
	};

	auto mclickID = [](int x)->int{
		switch(x)
		{
		case 0: return sl::MOUSE_MCLICK_NONE;
		case 1: return sl::MOUSE_MCLICK_MUTE;
		case 2: return sl::MOUSE_MCLICK_MINIMIZE_MUTE;
		case 3: return sl::MOUSE_MCLICK_PAUSE;
		case 4: return sl::MOUSE_MCLICK_MINIMIZE_PAUSE;
		case 5: return sl::MOUSE_MCLICK_THREAD_RESET;
		case 6: return sl::MOUSE_MCLICK_THREAD_RELOAD;
		case 7: return sl::MOUSE_MCLICK_BBS_EDIT;
		};
		return sl::MOUSE_MCLICK_MUTE;
	};

	auto ldblclickID = [](int x)->int{
		switch(x)
		{
		case 0: return sl::MOUSE_LDBLCLICK_NONE;
		case 1: return sl::MOUSE_LDBLCLICK_FULLSCREEN;
		case 2: return sl::MOUSE_LDBLCLICK_MAXIMIZE;
		case 3: return sl::MOUSE_LDBLCLICK_ZOOM100;
		case 4: return sl::MOUSE_LDBLCLICK_ZOOM100_FULLSCREEN;
		case 5: return sl::MOUSE_LDBLCLICK_ZOOM100_MAXIMIZE;
		};
		return sl::MOUSE_LDBLCLICK_FULLSCREEN;
	};

	mouse_.online.invert = m_xcCheckOnlineInvert.GetCheck() == BST_CHECKED;
	mouse_.online.wheel = wheelID(m_xcCmbOnlineWheel.GetCurSel());
	mouse_.online.mclick = mclickID(m_xcCmbOnlineMClick.GetCurSel());
	mouse_.online.ldblclick = ldblclickID(m_xcCmbOnlineLDBLClick.GetCurSel());

	mouse_.offline.invert = m_xcCheckOfflineInvert.GetCheck() == BST_CHECKED;
	mouse_.offline.wheel = wheelID(m_xcCmbOfflineWheel.GetCurSel());
	mouse_.offline.mclick = mclickID(m_xcCmbOfflineMClick.GetCurSel());
	mouse_.offline.ldblclick = ldblclickID(m_xcCmbOfflineLDBLClick.GetCurSel());

	mouse_.status.transfer = m_xcCheckStatusTransfer.GetCheck() == BST_CHECKED;
	mouse_.status.invert = m_xcCheckStatusInvert.GetCheck() == BST_CHECKED;
	mouse_.status.wheel = wheelID(m_xcCmbStatusWheel.GetCurSel());
	mouse_.status.mclick = mclickID(m_xcCmbStatusMClick.GetCurSel());

	mouse_.seek.transfer = m_xcCheckSeekTransfer.GetCheck() == BST_CHECKED;
	mouse_.seek.invert = m_xcCheckSeekInvert.GetCheck() == BST_CHECKED;
	mouse_.seek.wheel = wheelID(m_xcCmbSeekWheel.GetCurSel());
	mouse_.seek.mclick = mclickID(m_xcCmbSeekMClick.GetCurSel());

	mouse_.bbs.transfer = m_xcCheckBBSTransfer.GetCheck() == BST_CHECKED;
	mouse_.bbs.invert = m_xcCheckBBSInvert.GetCheck() == BST_CHECKED;
	mouse_.bbs.wheel = wheelID(m_xcCmbBBSWheel.GetCurSel());
	mouse_.bbs.mclick = mclickID(m_xcCmbBBSMClick.GetCurSel());
}


void COperationMouseDlg::OnBnClickedBtnAllDefault()
{
	mouse_ = sl::MouseOperation();

	init();
}


void COperationMouseDlg::OnBnClickedCheckStatusTransfer()
{
	statusEnableWindow();
}

void COperationMouseDlg::OnBnClickedCheckSeekTransfer()
{
	seekEnableWindow();
}

void COperationMouseDlg::OnBnClickedCheckBBSTransfer()
{
	bbsEnableWindow();
}


