// DisplayInformationMiscDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DisplayInformationGeneralDlg.h"
#include "afxdialogex.h"


// CDisplayInformationMiscDlg _CAO

IMPLEMENT_DYNAMIC(CDisplayInformationGeneralDlg, CDialog)

//CDisplayInformationGeneralDlg::CDisplayInformationGeneralDlg(CWnd* pParent /*=NULL*/)
//	: CDialog(CDisplayInformationGeneralDlg::IDD, pParent)
//{
//
//}

CDisplayInformationGeneralDlg::CDisplayInformationGeneralDlg(network::InformationControl& information)
	: CDialog(CDisplayInformationGeneralDlg::IDD, NULL)
	, information_(information)
{

}

CDisplayInformationGeneralDlg::~CDisplayInformationGeneralDlg()
{
}

void CDisplayInformationGeneralDlg::InitControls()
{
	m_xcCheckStatusName.SetCheck(information_.status.name ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckStatusType.SetCheck(information_.status.type ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckStatusGenre.SetCheck(information_.status.genre ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckStatusDesc.SetCheck(information_.status.desc ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckStatusComment.SetCheck(information_.status.comment ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckStatusArtist.SetCheck(information_.status.artist ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckStatusTitle.SetCheck(information_.status.title ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckStatusAlbum.SetCheck(information_.status.album ? BST_CHECKED : BST_UNCHECKED);

	m_xcCheckPanelName.SetCheck(information_.panel.name ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckPanelType.SetCheck(information_.panel.type ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckPanelGenre.SetCheck(information_.panel.genre ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckPanelDesc.SetCheck(information_.panel.desc ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckPanelComment.SetCheck(information_.panel.comment ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckPanelArtist.SetCheck(information_.panel.artist ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckPanelTitle.SetCheck(information_.panel.title ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckPanelAlbum.SetCheck(information_.panel.album ? BST_CHECKED : BST_UNCHECKED);
}

void CDisplayInformationGeneralDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK_STATUS_NAME, m_xcCheckStatusName);
	DDX_Control(pDX, IDC_CHECK_STATUS_TYPE, m_xcCheckStatusType);
	DDX_Control(pDX, IDC_CHECK_STATUS_GENRE, m_xcCheckStatusGenre);
	DDX_Control(pDX, IDC_CHECK_STATUS_DESC, m_xcCheckStatusDesc);
	DDX_Control(pDX, IDC_CHECK_STATUS_COMMENT, m_xcCheckStatusComment);
	DDX_Control(pDX, IDC_CHECK_STATUS_ARTIST, m_xcCheckStatusArtist);
	DDX_Control(pDX, IDC_CHECK_STATUS_TITLE, m_xcCheckStatusTitle);
	DDX_Control(pDX, IDC_CHECK_STATUS_ALBUM, m_xcCheckStatusAlbum);
	DDX_Control(pDX, IDC_CHECK_PANEL_NAME, m_xcCheckPanelName);
	DDX_Control(pDX, IDC_CHECK_PANEL_TYPE, m_xcCheckPanelType);
	DDX_Control(pDX, IDC_CHECK_PANEL_GENRE, m_xcCheckPanelGenre);
	DDX_Control(pDX, IDC_CHECK_PANEL_DESC, m_xcCheckPanelDesc);
	DDX_Control(pDX, IDC_CHECK_PANEL_COMMENT, m_xcCheckPanelComment);
	DDX_Control(pDX, IDC_CHECK_PANEL_ARTIST, m_xcCheckPanelArtist);
	DDX_Control(pDX, IDC_CHECK_PANEL_TITLE, m_xcCheckPanelTitle);
	DDX_Control(pDX, IDC_CHECK_PANEL_ALBUM, m_xcCheckPanelAlbum);
}


BEGIN_MESSAGE_MAP(CDisplayInformationGeneralDlg, CDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &CDisplayInformationGeneralDlg::OnBnClickedBtnAllDefault)
END_MESSAGE_MAP()


// CDisplayInformationMiscDlg bZ[W nh[


BOOL CDisplayInformationGeneralDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	InitControls();

	return TRUE;  // return TRUE unless you set the focus to a control
				  // O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDisplayInformationGeneralDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CDisplayInformationGeneralDlg::OnDestroy()
{
	CDialog::OnDestroy();

	information_.status.name = m_xcCheckStatusName.GetCheck() == BST_CHECKED;
	information_.status.type = m_xcCheckStatusType.GetCheck() == BST_CHECKED;
	information_.status.genre = m_xcCheckStatusGenre.GetCheck() == BST_CHECKED;
	information_.status.desc = m_xcCheckStatusDesc.GetCheck() == BST_CHECKED;
	information_.status.comment = m_xcCheckStatusComment.GetCheck() == BST_CHECKED;
	information_.status.artist = m_xcCheckStatusArtist.GetCheck() == BST_CHECKED;
	information_.status.title = m_xcCheckStatusTitle.GetCheck() == BST_CHECKED;
	information_.status.album = m_xcCheckStatusAlbum.GetCheck() == BST_CHECKED;

	information_.panel.name = m_xcCheckPanelName.GetCheck() == BST_CHECKED;
	information_.panel.type = m_xcCheckPanelType.GetCheck() == BST_CHECKED;
	information_.panel.genre = m_xcCheckPanelGenre.GetCheck() == BST_CHECKED;
	information_.panel.desc = m_xcCheckPanelDesc.GetCheck() == BST_CHECKED;
	information_.panel.comment = m_xcCheckPanelComment.GetCheck() == BST_CHECKED;
	information_.panel.artist = m_xcCheckPanelArtist.GetCheck() == BST_CHECKED;
	information_.panel.title = m_xcCheckPanelTitle.GetCheck() == BST_CHECKED;
	information_.panel.album = m_xcCheckPanelAlbum.GetCheck() == BST_CHECKED;
}


void CDisplayInformationGeneralDlg::OnBnClickedBtnAllDefault()
{
	auto tmp = network::InformationControl();
	information_.status = tmp.status;
	information_.panel = tmp.panel;
	InitControls();
}
